//------------//
// Question 1
function y=distrib_binomiale(n,p)
    // version itérative
    y=zeros(1,n+1);
    // ci-dessous on met à jour le vecteur y pour que y(1,k) contienne P(X=k-1) pour 1<=k<=n+1
    y(1)=(1-p)^n;
    for k=1:n
        // P(X=k)=(n-k+1)/k*p/(1-p)*P(X=k-1)
        y(k+1)=(n-k+1)/k*p/(1-p)*y(k);
    end
endfunction

function y=distrib_binomiale(n,p)
    // version matricielle
    k=1:n;
    y=(1-p)^n*[1, cumprod(p/(1-p)*(n-k+1)./k)];
endfunction

//------------//
// Question 2
n=30;
p=.4;    // choix des paramètres
x=0:n;    // support de la loi
y=distrib_binomiale2(n,p);  // acquisition de la loi

clf
bar(x,y);
