function [x,y]=escargot(x0,n)
    x=zeros(1,2*n+1);
    y=x;
    x(1)=x0;
    for k=1:n
        x(2*k)=x(2*k-1);
        y(2*k)=f(x(2*k));
        x(2*k+1)=y(2*k);
        y(2*k+1)=x(2*k+1);
    end
endfunction

function y=f(x)
    y=(4-x^2)/3;
endfunction

n=15;
x0=3;
[x,y]=escargot(x0,n);
t=linspace(min(x),max(x),100);

clf
plot2d(x,x);
fplot2d(t,f);
plot2d(x,y);
