//------------//
// Question 1
function y=distrib_geometrique(n,p)
    // y=p*(1-p).^(0:(n-1));  // pas très efficace
    y=cumprod((1-p)*ones(1,n))*p/(1-p);  // plus efficace
endfunction

//------------------//
// Questions 2 et 3
n=20;
p=.5;    // choix des paramètres
x=1:n;    // support de la loi (tronqué)
y=distrib_geometrique(n,p);  // acquisition de la loi
F=cumsum(y);    // valeurs de la fonction de répartition

clf
subplot(121)
// Représentation graphique de la loi dans la fenêtre de gauche
    bar(x,y);
subplot(122)
// Fonction de répartition dans la fenêtre de droite
    bar(x,F);
